<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: src/core/CL/cl_kernels/non_linear_filter_helpers.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.xhtml"><span>File&#160;List</span></a></li>
      <li><a href="globals.xhtml"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('non__linear__filter__helpers_8h_source.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">non_linear_filter_helpers.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="non__linear__filter__helpers_8h.xhtml">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2017 ARM Limited.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-License-Identifier: MIT</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a copy</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * of this software and associated documentation files (the &quot;Software&quot;), to</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * deal in the Software without restriction, including without limitation the</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * sell copies of the Software, and to permit persons to whom the Software is</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * furnished to do so, subject to the following conditions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * The above copyright notice and this permission notice shall be included in all</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * copies or substantial portions of the Software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> * SOFTWARE.</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">   30</a></span>&#160;<span class="preprocessor">#define SORT(a, b)                  \</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">    {                               \</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">        uchar8 min_val = min(a, b); \</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">        uchar8 max_val = max(a, b); \</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">        a              = min_val;   \</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">        b              = max_val;   \</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">    }</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment">// Sorting networks below were generated using http://pages.ripco.net/~jgamble/nw.html</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="non__linear__filter__helpers_8h.xhtml#a7b5c174de888c3cfa7c08c16682fd770">   50</a></span>&#160;<span class="keyword">inline</span> uchar8 <a class="code" href="non__linear__filter__helpers_8h.xhtml#a7b5c174de888c3cfa7c08c16682fd770">sort5</a>(uchar8 p0, uchar8 p1, uchar8 p2, uchar8 p3, uchar8 p4)</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;{</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p1);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p3);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p2);</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p3);</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p2);</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p4);</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p4);</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p4);</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordflow">return</span> p2;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;}</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="non__linear__filter__helpers_8h.xhtml#a0960df49e39a9499677066c32600c17f">   78</a></span>&#160;<span class="keyword">inline</span> uchar8 <a class="code" href="non__linear__filter__helpers_8h.xhtml#a0960df49e39a9499677066c32600c17f">sort9</a>(uchar8 p0, uchar8 p1, uchar8 p2, uchar8 p3, uchar8 p4, uchar8 p5, uchar8 p6, uchar8 p7, uchar8 p8)</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;{</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p2);</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p5);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p8);</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p1);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p4);</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p7);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p2);</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p5);</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p8);</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p3);</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p8);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p7);</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p6);</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p4);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p5);</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p7);</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p2);</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p4);</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p2);</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keywordflow">return</span> p4;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;}</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="non__linear__filter__helpers_8h.xhtml#ae3e09114bb887de4e20122eed42671a1">  109</a></span>&#160;<span class="keyword">inline</span> uchar8 <a class="code" href="non__linear__filter__helpers_8h.xhtml#ae3e09114bb887de4e20122eed42671a1">row_reduce_min_3</a>(uchar16 val)</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;{</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keywordflow">return</span> min(val.s01234567, min(val.s12345678, val.s23456789));</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;}</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno"><a class="line" href="non__linear__filter__helpers_8h.xhtml#a3138dafa8474a59f73dd837073f18ed7">  120</a></span>&#160;<span class="keyword">inline</span> uchar8 <a class="code" href="non__linear__filter__helpers_8h.xhtml#a3138dafa8474a59f73dd837073f18ed7">row_reduce_max_3</a>(uchar16 val)</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;{</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordflow">return</span> max(val.s01234567, max(val.s12345678, val.s23456789));</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;}</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno"><a class="line" href="non__linear__filter__helpers_8h.xhtml#aa9d1bdcaf911a5b861c2082181e6a716">  131</a></span>&#160;<span class="keyword">inline</span> uchar8 <a class="code" href="non__linear__filter__helpers_8h.xhtml#aa9d1bdcaf911a5b861c2082181e6a716">row_reduce_min_5</a>(uchar16 val)</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;{</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keywordflow">return</span> min(val.s01234567, min(min(val.s12345678, val.s23456789), min(val.s3456789A, val.s456789AB)));</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;}</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00142"></a><span class="lineno"><a class="line" href="non__linear__filter__helpers_8h.xhtml#a310f21b7cf0409431ddf246c4a98e52e">  142</a></span>&#160;<span class="keyword">inline</span> uchar8 <a class="code" href="non__linear__filter__helpers_8h.xhtml#a310f21b7cf0409431ddf246c4a98e52e">row_reduce_max_5</a>(uchar16 val)</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;{</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="keywordflow">return</span> max(val.s01234567, max(max(val.s12345678, val.s23456789), max(val.s3456789A, val.s456789AB)));</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;}</div><div class="ttc" id="non__linear__filter__helpers_8h_xhtml_aa9d1bdcaf911a5b861c2082181e6a716"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#aa9d1bdcaf911a5b861c2082181e6a716">row_reduce_min_5</a></div><div class="ttdeci">uchar8 row_reduce_min_5(uchar16 val)</div><div class="ttdoc">Calculate the minimum of a sliding window of size 5. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00131">non_linear_filter_helpers.h:131</a></div></div>
<div class="ttc" id="non__linear__filter__helpers_8h_xhtml_ac226bc1ed04fd7d4865263484ed22a47"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a></div><div class="ttdeci">#define SORT(a, b)</div><div class="ttdoc">Sorts element-wise two vectors. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00030">non_linear_filter_helpers.h:30</a></div></div>
<div class="ttc" id="non__linear__filter__helpers_8h_xhtml_a310f21b7cf0409431ddf246c4a98e52e"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#a310f21b7cf0409431ddf246c4a98e52e">row_reduce_max_5</a></div><div class="ttdeci">uchar8 row_reduce_max_5(uchar16 val)</div><div class="ttdoc">Calculate the maximum of a sliding window of size 5. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00142">non_linear_filter_helpers.h:142</a></div></div>
<div class="ttc" id="non__linear__filter__helpers_8h_xhtml_a7b5c174de888c3cfa7c08c16682fd770"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#a7b5c174de888c3cfa7c08c16682fd770">sort5</a></div><div class="ttdeci">uchar8 sort5(uchar8 p0, uchar8 p1, uchar8 p2, uchar8 p3, uchar8 p4)</div><div class="ttdoc">Sorting network to sort 5 vectors of 8 elements and return their median. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00050">non_linear_filter_helpers.h:50</a></div></div>
<div class="ttc" id="non__linear__filter__helpers_8h_xhtml_a3138dafa8474a59f73dd837073f18ed7"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#a3138dafa8474a59f73dd837073f18ed7">row_reduce_max_3</a></div><div class="ttdeci">uchar8 row_reduce_max_3(uchar16 val)</div><div class="ttdoc">Calculate the maximum of a sliding window of size 3. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00120">non_linear_filter_helpers.h:120</a></div></div>
<div class="ttc" id="non__linear__filter__helpers_8h_xhtml_a0960df49e39a9499677066c32600c17f"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#a0960df49e39a9499677066c32600c17f">sort9</a></div><div class="ttdeci">uchar8 sort9(uchar8 p0, uchar8 p1, uchar8 p2, uchar8 p3, uchar8 p4, uchar8 p5, uchar8 p6, uchar8 p7, uchar8 p8)</div><div class="ttdoc">Sorting network to sort 9 vectors of 8 elements and return their median. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00078">non_linear_filter_helpers.h:78</a></div></div>
<div class="ttc" id="non__linear__filter__helpers_8h_xhtml_ae3e09114bb887de4e20122eed42671a1"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#ae3e09114bb887de4e20122eed42671a1">row_reduce_min_3</a></div><div class="ttdeci">uchar8 row_reduce_min_3(uchar16 val)</div><div class="ttdoc">Calculate the minimum of a sliding window of size 3. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00109">non_linear_filter_helpers.h:109</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.xhtml">src</a></li><li class="navelem"><a class="el" href="dir_aebb8dcc11953d78e620bbef0b9e2183.xhtml">core</a></li><li class="navelem"><a class="el" href="dir_8c278f79c760e5c5fbd911f9870614c1.xhtml">CL</a></li><li class="navelem"><a class="el" href="dir_25885286e9dad4fa105b7b25a8031bbf.xhtml">cl_kernels</a></li><li class="navelem"><a class="el" href="non__linear__filter__helpers_8h.xhtml">non_linear_filter_helpers.h</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:09 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
